
/**
 * Basic node stored in a binary search tree.
 */

public class BSTNode {
  /**
   * The key of the node.
   */
  protected Comparable key; // interface Comparable richiede metodo compareTo

  /**
   * The left child node of current node.
   */
  protected BSTNode leftChild;

  /**
   * The right child node of current node.
   */
  protected BSTNode rightChild;

    /**
     * Constructs a new node.
     */
    public BSTNode() {
        leftChild = rightChild = null;
    }

    /**
     * Constructs a new node.
     * @param el the element to insert.
     */
    public BSTNode(Comparable el) {
        this(el,null,null);
    }

    /**
     *
     * @param el
     * @param lt
     * @param rt
     */
    protected BSTNode(Comparable el, BSTNode lt, BSTNode rt) {
        key = el; leftChild = lt; rightChild = rt;
    }

    /**
     * Returns the key of the node.
     * @return the key of this node
     */
    public Comparable getKey() {
            return key;
    }

    /**
     * Returns the left child of the node.
     * @return the left child <b>BSTNode</b>.
     */
    public BSTNode getLeftChild() {
            return leftChild;
    }

    /**
     * Returns the right child of the node.
     * @return the right child <b>BSTNode</b>.
     */
    public BSTNode getRightChild() {
            return rightChild;
    }

    /**
     * Prints the <b>String</b> that represents the key of the node.
     */
    public void visit() {
        System.out.print(key.toString());
    }

    /**
     * Verifies if this <b>BSTNode</b> is a leaf.
     * @return true if this node is a leaf, false otherwise.
     */
    public boolean isLeaf() {
            return (leftChild == null) && (rightChild == null);
    }
}

